



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Redis—数据结构之sds</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Redis—数据结构之sds</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 05:45:00 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Redis是一个Key Value数据库。Redis有5种数据类型：字符串、列表、哈希、集合、有序集合。而字符串的底层实现方法之一就是使用sds。以下描述中请读者注意区分sds是指简单动态字符串这一数据结构(用大写表示)还是sdshdr头部中buf数组的起始地址(用小写表示)。</p>
<h3>SDS源码</h3>
<p>如下源码所示。</p>
<p>根据要保存的字符串长度选用不同的头部大小，从而节省内存，注意sdshdr5与其他不同，下面会有介绍。</p>
<p>SDS由两部分组成：sds、sdshdr。sds是一个char类型的指针，指向buf数组首元素，buf数组是存储字符串的实际位置；sdshdr是SDS的头部，为SDS加上一个头部的好处就是为了提高某些地方的效率，比如获取buf数组中字符串长度，用O（1）的复杂度从头部就能取得。buf数组是一个空数组，从而使得sdshdr是一个可变长度的结构体，用一个空数组的好处就是分配内存时，只用分配一次，而且头部所占用的内存和sds的内存是连续的，释放时也只用释放一次。</p>
<p>sdshdr结构体中各字段的介绍：len : 已存储的字符串长度；alloc : 能存储的字符串的最大容量，不包括SDS头部和结尾的NULL字符；flags : 标志位，低3位代表了sds头部类型，高5位未用；buf[] : 字符数组，存储字符串；注意sdshdr5没有len和alloc字段，其flags的低3位同样代表头部类型，但高5位代表保存的字符串长度。&nbsp;__attribute__ ((__packed__)) :&nbsp;使得编译器不会因为内存对齐而在结构体中填充字节，以保证内存的紧凑，这样sds - 1就可以得到flags字段，进而能够得到其头部类型。如果填充了字节，则就不能得到flags字段。</p>
<p>buf数组尾部隐含有一个'\0'，SDS是以len字段来判断是否到达字符串末尾，而不是以'\0'判断结尾。所以sds存储的字符串中间可以出现'\0'，即sds字符串是二进制安全的。</p>
<div>
<pre class="prettyprint linenums">typedef char *sds;

struct __attribute__ ((__packed__)) sdshdr5 {<br />
    unsigned char flags; /* 3 lsb of type, and 5 msb of string length */<br />
    char buf[];<br />
};<br />
struct __attribute__ ((__packed__)) sdshdr8 {<br />
    uint8_t len; /* used */<br />
    uint8_t alloc; /* excluding the header and null terminator */<br />
    unsigned char flags; /* 3 lsb of type, 5 unused bits */<br />
    char buf[];<br />
};<br />
struct __attribute__ ((__packed__)) sdshdr16 {<br />
    uint16_t len; /* used */<br />
    uint16_t alloc; /* excluding the header and null terminator */<br />
    unsigned char flags; /* 3 lsb of type, 5 unused bits */<br />
    char buf[];<br />
};<br />
struct __attribute__ ((__packed__)) sdshdr32 {<br />
    uint32_t len; /* used */<br />
    uint32_t alloc; /* excluding the header and null terminator */<br />
    unsigned char flags; /* 3 lsb of type, 5 unused bits */<br />
    char buf[];<br />
};<br />
struct __attribute__ ((__packed__)) sdshdr64 {<br />
    uint64_t len; /* used */<br />
    uint64_t alloc; /* excluding the header and null terminator */<br />
    unsigned char flags; /* 3 lsb of type, 5 unused bits */<br />
    char buf[];<br />
};</pre>
</div>
<p>既然有这么多类型的头部，一定会有类似宏定义之类能够标识头部，的确有，如下所示：</p>
<div>
<pre class="prettyprint linenums">// flags的低三位代表不同类型的sds头部：<br />
#define SDS_TYPE_5  0<br />
#define SDS_TYPE_8  1<br />
#define SDS_TYPE_16 2<br />
#define SDS_TYPE_32 3<br />
#define SDS_TYPE_64 4<br />
#define SDS_TYPE_MASK 7<br />
#define SDS_TYPE_BITS 3</pre>
</div>
<h3>SDS操作</h3>
<p>因为sds和头部是内存连续的，所以当我们得到了一个sds，只要将它-1就可得到flags字段，减头部大小即可得到头部起始地址。SDS的很多操作就是利用了这一点，从而带来了极大的方便和快速。下面我们介绍几个SDS比较重要的几个操作</p>
<p><strong>1. 获取头部起始地址</strong></p>
<p>将sds减去头部大小即可。非常方便快速。</p>
<div>
<pre class="prettyprint linenums">// 返回一个指向sds头部的起始地址的指针<br />
#define SDS_HDR_VAR(T,s) struct sdshdr##T *sh = (void*)((s)-(sizeof(struct sdshdr##T)));<br />
// 返回sds头部的起始地址<br />
#define SDS_HDR(T,s) ((struct sdshdr##T *)((s)-(sizeof(struct sdshdr##T))))</pre>
</div>
<p><strong>2.&nbsp;获取buf数组中sds存储的字符串长度</strong></p>
<p>先后移1位，得到flags字段，再和掩码相与即可得到头部类型。</p>
<div>
<pre class="prettyprint linenums">static inline size_t sdslen(const sds s) {<br />
    unsigned char flags = s[-]; // 内存空间连续，所以往后移1个字节，便是flags字段<br />
    switch(flags&amp;SDS_TYPE_MASK) { // 和flags低3位相与，得到sds头部类型<br />
        case SDS_TYPE_5:<br />
            return SDS_TYPE_5_LEN(flags);<br />
        case SDS_TYPE_8:<br />
            return SDS_HDR(,s)-&gt;len; // 先移动到sds头部的起始地址，进而可以直接获取len字段的值。下同<br />
        case SDS_TYPE_16:<br />
            return SDS_HDR(,s)-&gt;len;<br />
        case SDS_TYPE_32:<br />
            return SDS_HDR(,s)-&gt;len;<br />
        case SDS_TYPE_64:<br />
            return SDS_HDR(,s)-&gt;len;<br />
    }<br />
    return ;<br />
}</pre>
</div>
<p><strong>3.&nbsp;获取buf数组中剩余可用的内存大小</strong></p>
<div>
<pre class="prettyprint linenums">static inline size_t sdsavail(const sds s) {<br />
    unsigned char flags = s[-]; // 后移1字节，得到flags字段<br />
    switch(flags&amp;SDS_TYPE_MASK) { // 得到sds头部类型<br />
        case SDS_TYPE_5: {<br />
            return ;<br />
        }<br />
        case SDS_TYPE_8: {<br />
            SDS_HDR_VAR(,s);<br />
            return sh-&gt;alloc - sh-&gt;len; // 总大小减去已使用大小<br />
        }<br />
        case SDS_TYPE_16: {<br />
            SDS_HDR_VAR(,s);<br />
            return sh-&gt;alloc - sh-&gt;len;<br />
        }<br />
        case SDS_TYPE_32: {<br />
            SDS_HDR_VAR(,s);<br />
            return sh-&gt;alloc - sh-&gt;len;<br />
        }<br />
        case SDS_TYPE_64: {<br />
            SDS_HDR_VAR(,s);<br />
            return sh-&gt;alloc - sh-&gt;len;<br />
        }<br />
    }<br />
    return ;<br />
}</pre>
</div>
<p><strong>4. 使用字符串初始化一个SDS</strong></p>
<p>注意分配时，程序会自动为buf数组最后一个元素后面添加上'\0'，'\0'对外部完全是透明的，分配内存时自动多分配1个字节保存'\0'，buf数组最后自动添加'\0'。</p>
<div>
<div>
<pre class="prettyprint linenums">// sds尾部隐含有一个'\0'；sds是以len字段来判断是否到达字符串末尾<br />
// 所以sds存储的字符串中间可以出现'\0'，即sds字符串是二进制安全的

// 分配一个新sds，buf数组存储内容init<br />
sds sdsnewlen(const void *init, size_t initlen) {<br />
    void *sh;<br />
    sds s;<br />
    char type = sdsReqType(initlen); // 根据长度大小选择合适的sds头部<br />
    /* Empty strings are usually created in order to append. Use type 8<br />
     * since type 5 is not good at this. */<br />
    if (type == SDS_TYPE_5 &amp;&amp; initlen == ) type = SDS_TYPE_8;<br />
    int hdrlen = sdsHdrSize(type); // 获取sds头部大小<br />
    unsigned char *fp; /* flags pointer. */

    // 为sds分配内存，总大小为：头部大小+存储字符串的长度+末尾隐含的空字符大小<br />
    sh = s_malloc(hdrlen+initlen+);<br />
    if (!init)<br />
        memset(sh, , hdrlen+initlen+); // 内存初始化为0<br />
    if (sh == NULL) return NULL;<br />
    s = (char*)sh+hdrlen; // buf数组的起始地址<br />
    fp = ((unsigned char*)s)-; // 指向flags字段<br />
    // 初始化sds头部的len,alloc,flags字段<br />
    switch(type) {<br />
        case SDS_TYPE_5: {<br />
            *fp = type | (initlen &lt;&lt; SDS_TYPE_BITS);<br />
            break;<br />
        }<br />
        case SDS_TYPE_8: {<br />
            SDS_HDR_VAR(,s);<br />
            sh-&gt;len = initlen;<br />
            sh-&gt;alloc = initlen;<br />
            *fp = type;<br />
            break;<br />
        }<br />
        case SDS_TYPE_16: {<br />
            SDS_HDR_VAR(,s);<br />
            sh-&gt;len = initlen;<br />
            sh-&gt;alloc = initlen;<br />
            *fp = type;<br />
            break;<br />
        }<br />
        case SDS_TYPE_32: {<br />
            SDS_HDR_VAR(,s);<br />
            sh-&gt;len = initlen;<br />
            sh-&gt;alloc = initlen;<br />
            *fp = type;<br />
            break;<br />
        }<br />
        case SDS_TYPE_64: {<br />
            SDS_HDR_VAR(,s);<br />
            sh-&gt;len = initlen;<br />
            sh-&gt;alloc = initlen;<br />
            *fp = type;<br />
            break;<br />
        }<br />
    }<br />
    // 初始化buf数组<br />
    if (initlen &amp;&amp; init)<br />
        memcpy(s, init, initlen); // 拷贝init到buf数组<br />
    s[initlen] = '\0'; // 添加末尾的空字符<br />
    return s;<br />
}</pre>
</div>
</div>
<p><strong>5. 空间预分配</strong></p>
<p>当需要将SDS的len增加addlen个字节时，如果SDS剩余空间足够，则什么都不用做。如果剩余空间不够，则会分配新的内存空间，并且采用预分配。新长度newlen为原len+addlen，若newlen小于1M，则为SDS分配新的内存大小为2*newlen；若newlen大于等于1M，则SDS分配新的内存大小为newlen &nbsp;+ 1M。</p>
<div>
<div>
<pre class="prettyprint linenums"> // 为sds的len字段增加addlen个字节，剩余空间不足时会引起空间重新分配<br />
sds sdsMakeRoomFor(sds s, size_t addlen) {<br />
    void *sh, *newsh;<br />
    size_t avail = sdsavail(s);<br />
    size_t len, newlen;<br />
    char type, oldtype = s[-] &amp; SDS_TYPE_MASK;<br />
    int hdrlen;

    /* Return ASAP if there is enough space left. */<br />
    if (avail &gt;= addlen) return s; // sds剩余空间足够

    len = sdslen(s);<br />
    sh = (char*)s-sdsHdrSize(oldtype);<br />
    newlen = (len+addlen); // sds剩余空间不够，新的len为len+addlen

    // 下面两步实现空间预分配<br />
    if (newlen &lt; SDS_MAX_PREALLOC) // 新长度小于1M，则len设为2*(len+addlen)大小<br />
        newlen *= ;<br />
    else<br />
        newlen += SDS_MAX_PREALLOC; // 新长度大于1M，则len设为 len+1M 大小

    type = sdsReqType(newlen); // 新len对应的sds头部

    /* Don't use type 5: the user is appending to the string and type 5 is<br />
     * not able to remember empty space, so sdsMakeRoomFor() must be called<br />
     * at every appending operation. */<br />
    if (type == SDS_TYPE_5) type = SDS_TYPE_8;

    hdrlen = sdsHdrSize(type);<br />
    if (oldtype==type) {<br />
        newsh = s_realloc(sh, hdrlen+newlen+);<br />
        if (newsh == NULL) return NULL;<br />
        s = (char*)newsh+hdrlen;<br />
    } else {<br />
        /* Since the header size changes, need to move the string forward,<br />
         * and can't use realloc */<br />
        newsh = s_malloc(hdrlen+newlen+);<br />
        if (newsh == NULL) return NULL;<br />
        memcpy((char*)newsh+hdrlen, s, len+);<br />
        s_free(sh);<br />
        s = (char*)newsh+hdrlen;<br />
        s[-] = type;<br />
        sdssetlen(s, len);<br />
    }<br />
    sdssetalloc(s, newlen);<br />
    return s;<br />
}</pre>
</div>
</div>
<p><strong>6. 惰性空间释放</strong></p>
<p>当要清空一个SDS时，并不真正释放其内存，而是设置len字段为0即可，这样当之后再次使用到该SDS时，可避免重新分配内存，从而提高效率。</p>
<div>
<pre class="prettyprint linenums"> // 清空sds内容，len字段清为0<br />
 // 但之前的空间并未释放，可避免以后的重新分配内存。实现惰性空间释放<br />
void sdsclear(sds s) {<br />
    sdssetlen(s, );<br />
    s[] = '\0';<br />
}</pre>
</div>
<p>只要理解了sds和sdshdr，其操作函数便很容易理解。剩下的就不一一介绍了，我在阅读过程中也做了部分注释，下面附上源码及注释。SDS共两个文件：sds.h和sds.c</p>
<p>sds.h :</p>
<div>
<div>
<pre class="prettyprint linenums">/* SDSLib 2.0 -- A C dynamic strings library<br />
 * 简单动态字符串<br />
 */

#ifndef __SDS_H<br />
#define __SDS_H

#define SDS_MAX_PREALLOC (1024*1024) // 1M，空间预分配使用

#include &lt;sys/types.h&gt;<br />
#include &lt;stdarg.h&gt;<br />
#include &lt;stdint.h&gt;

// 指向存储数据的起始地址<br />
typedef char *sds;

/* Note: sdshdr5 is never used, we just access the flags byte directly.<br />
 * However is here to document the layout of type 5 SDS strings. */

// sds由两部分组成：sds头部(即下面的各种结构体)、真正存储字符串的字符数组<br />
// 这两部分在内存上连续<br />
// len : 已存储的字符串长度<br />
// alloc : 能存储的字符串的最大容量，不包括sds头部和结尾的NULL字符<br />
// flags : 标志位，最低三位代表了sds头部类型<br />
// buf[] : 字符数组，存储字符串<br />
// __attribute__ ((__packed__)) :<br />
// 使得编译器不会因为内存对齐而在结构体中填充字节，以保证内存的紧凑，使得下面的s[-1]得到正确的地址<br />
// char buf[] : 初始时不占用内存，而且使得头部内存和存储字符串的内存地址连续。<br />
// sdshdr5比较特殊,flags字段低3位代表sds头部类型，高5位代表已存储的字符串长度<br />
// 分为不同类型的头部，目的是为了存储不同长度的字符串使用不同类型，从而节省内存

 struct __attribute__ ((__packed__)) sdshdr5 {<br />
    unsigned char flags; /* 3 lsb of type, and 5 msb of string length */<br />
    char buf[];<br />
};<br />
struct __attribute__ ((__packed__)) sdshdr8 {<br />
    uint8_t len; /* used */<br />
    uint8_t alloc; /* excluding the header and null terminator */<br />
    unsigned char flags; /* 3 lsb of type, 5 unused bits */<br />
    char buf[];<br />
};<br />
struct __attribute__ ((__packed__)) sdshdr16 {<br />
    uint16_t len; /* used */<br />
    uint16_t alloc; /* excluding the header and null terminator */<br />
    unsigned char flags; /* 3 lsb of type, 5 unused bits */<br />
    char buf[];<br />
};<br />
struct __attribute__ ((__packed__)) sdshdr32 {<br />
    uint32_t len; /* used */<br />
    uint32_t alloc; /* excluding the header and null terminator */<br />
    unsigned char flags; /* 3 lsb of type, 5 unused bits */<br />
    char buf[];<br />
};<br />
struct __attribute__ ((__packed__)) sdshdr64 {<br />
    uint64_t len; /* used */<br />
    uint64_t alloc; /* excluding the header and null terminator */<br />
    unsigned char flags; /* 3 lsb of type, 5 unused bits */<br />
    char buf[];<br />
};

// flags的低三位代表不同类型的sds头部：<br />
#define SDS_TYPE_5  0<br />
#define SDS_TYPE_8  1<br />
#define SDS_TYPE_16 2<br />
#define SDS_TYPE_32 3<br />
#define SDS_TYPE_64 4<br />
#define SDS_TYPE_MASK 7<br />
#define SDS_TYPE_BITS 3

// 返回一个指向sds头部的起始地址的指针<br />
#define SDS_HDR_VAR(T,s) struct sdshdr##T *sh = (void*)((s)-(sizeof(struct sdshdr##T)));<br />
// 返回sds头部的起始地址<br />
#define SDS_HDR(T,s) ((struct sdshdr##T *)((s)-(sizeof(struct sdshdr##T))))<br />
// 获取sdshdr5类型的sds存储的字符串长度<br />
#define SDS_TYPE_5_LEN(f) ((f)&gt;&gt;SDS_TYPE_BITS)

// 获取buf数组中sds存储的字符串长度<br />
static inline size_t sdslen(const sds s) {<br />
    unsigned char flags = s[-]; // 内存空间连续，所以往后移1个字节，便是flags字段<br />
    switch(flags&amp;SDS_TYPE_MASK) { // 和flags低3位相与，得到sds头部类型<br />
        case SDS_TYPE_5:<br />
            return SDS_TYPE_5_LEN(flags);<br />
        case SDS_TYPE_8:<br />
            return SDS_HDR(,s)-&gt;len; // 先移动到sds头部的起始地址，进而可以直接获取len字段的值。下同<br />
        case SDS_TYPE_16:<br />
            return SDS_HDR(,s)-&gt;len;<br />
        case SDS_TYPE_32:<br />
            return SDS_HDR(,s)-&gt;len;<br />
        case SDS_TYPE_64:<br />
            return SDS_HDR(,s)-&gt;len;<br />
    }<br />
    return ;<br />
}

// 获取buf数组中剩余可用的内存大小<br />
static inline size_t sdsavail(const sds s) {<br />
    unsigned char flags = s[-]; // 后移1字节，得到flags字段<br />
    switch(flags&amp;SDS_TYPE_MASK) { // 得到sds头部类型<br />
        case SDS_TYPE_5: {<br />
            return ;<br />
        }<br />
        case SDS_TYPE_8: {<br />
            SDS_HDR_VAR(,s);<br />
            return sh-&gt;alloc - sh-&gt;len; // 总大小减去已使用大小<br />
        }<br />
        case SDS_TYPE_16: {<br />
            SDS_HDR_VAR(,s);<br />
            return sh-&gt;alloc - sh-&gt;len;<br />
        }<br />
        case SDS_TYPE_32: {<br />
            SDS_HDR_VAR(,s);<br />
            return sh-&gt;alloc - sh-&gt;len;<br />
        }<br />
        case SDS_TYPE_64: {<br />
            SDS_HDR_VAR(,s);<br />
            return sh-&gt;alloc - sh-&gt;len;<br />
        }<br />
    }<br />
    return ;<br />
}

// 设置sds头部的len字段<br />
static inline void sdssetlen(sds s, size_t newlen) {<br />
    unsigned char flags = s[-];<br />
    switch(flags&amp;SDS_TYPE_MASK) {<br />
        case SDS_TYPE_5:<br />
            {<br />
                // 对于sdshdr5，则是设置flags的高5位<br />
                unsigned char *fp = ((unsigned char*)s)-;<br />
                *fp = SDS_TYPE_5 | (newlen &lt;&lt; SDS_TYPE_BITS);<br />
            }<br />
            break;<br />
        case SDS_TYPE_8:<br />
            SDS_HDR(,s)-&gt;len = newlen;<br />
            break;<br />
        case SDS_TYPE_16:<br />
            SDS_HDR(,s)-&gt;len = newlen;<br />
            break;<br />
        case SDS_TYPE_32:<br />
            SDS_HDR(,s)-&gt;len = newlen;<br />
            break;<br />
        case SDS_TYPE_64:<br />
            SDS_HDR(,s)-&gt;len = newlen;<br />
            break;<br />
    }<br />
}

// 将sds头部的len字段增加inc<br />
static inline void sdsinclen(sds s, size_t inc) {<br />
    unsigned char flags = s[-];<br />
    switch(flags&amp;SDS_TYPE_MASK) {<br />
        case SDS_TYPE_5:<br />
            {<br />
                // 对于sdshdr5，则是设置flags的高5位<br />
                unsigned char *fp = ((unsigned char*)s)-;<br />
                unsigned char newlen = SDS_TYPE_5_LEN(flags)+inc;<br />
                *fp = SDS_TYPE_5 | (newlen &lt;&lt; SDS_TYPE_BITS);<br />
            }<br />
            break;<br />
        case SDS_TYPE_8:<br />
            SDS_HDR(,s)-&gt;len += inc;<br />
            break;<br />
        case SDS_TYPE_16:<br />
            SDS_HDR(,s)-&gt;len += inc;<br />
            break;<br />
        case SDS_TYPE_32:<br />
            SDS_HDR(,s)-&gt;len += inc;<br />
            break;<br />
        case SDS_TYPE_64:<br />
            SDS_HDR(,s)-&gt;len += inc;<br />
            break;<br />
    }<br />
}

/* sdsalloc() = sdsavail() + sdslen() */<br />
// 获取sds的buf数组总的大小<br />
static inline size_t sdsalloc(const sds s) {<br />
    unsigned char flags = s[-];<br />
    switch(flags&amp;SDS_TYPE_MASK) {<br />
        case SDS_TYPE_5:<br />
            return SDS_TYPE_5_LEN(flags);<br />
        case SDS_TYPE_8:<br />
            return SDS_HDR(,s)-&gt;alloc;<br />
        case SDS_TYPE_16:<br />
            return SDS_HDR(,s)-&gt;alloc;<br />
        case SDS_TYPE_32:<br />
            return SDS_HDR(,s)-&gt;alloc;<br />
        case SDS_TYPE_64:<br />
            return SDS_HDR(,s)-&gt;alloc;<br />
    }<br />
    return ;<br />
}

// 设置sds的buf数组总的大小<br />
static inline void sdssetalloc(sds s, size_t newlen) {<br />
    unsigned char flags = s[-];<br />
    switch(flags&amp;SDS_TYPE_MASK) {<br />
        case SDS_TYPE_5:<br />
            /* Nothing to do, this type has no total allocation info. */<br />
            break;<br />
        case SDS_TYPE_8:<br />
            SDS_HDR(,s)-&gt;alloc = newlen;<br />
            break;<br />
        case SDS_TYPE_16:<br />
            SDS_HDR(,s)-&gt;alloc = newlen;<br />
            break;<br />
        case SDS_TYPE_32:<br />
            SDS_HDR(,s)-&gt;alloc = newlen;<br />
            break;<br />
        case SDS_TYPE_64:<br />
            SDS_HDR(,s)-&gt;alloc = newlen;<br />
            break;<br />
    }<br />
}

sds sdsnewlen(const void *init, size_t initlen);<br />
sds sdsnew(const char *init);<br />
sds sdsempty(void);<br />
sds sdsdup(const sds s);<br />
void sdsfree(sds s);<br />
sds sdsgrowzero(sds s, size_t len);<br />
sds sdscatlen(sds s, const void *t, size_t len);<br />
sds sdscat(sds s, const char *t);<br />
sds sdscatsds(sds s, const sds t);<br />
sds sdscpylen(sds s, const char *t, size_t len);<br />
sds sdscpy(sds s, const char *t);

sds sdscatvprintf(sds s, const char *fmt, va_list ap);<br />
#ifdef __GNUC__<br />
sds sdscatprintf(sds s, const char *fmt, ...)<br />
    __attribute__((format(printf, , )));<br />
#else<br />
sds sdscatprintf(sds s, const char *fmt, ...);<br />
#endif

sds sdscatfmt(sds s, char const *fmt, ...);<br />
sds sdstrim(sds s, const char *cset);<br />
void sdsrange(sds s, int start, int end);<br />
void sdsupdatelen(sds s);<br />
void sdsclear(sds s);<br />
int sdscmp(const sds s1, const sds s2);<br />
sds *sdssplitlen(const char *s, int len, const char *sep, int seplen, int *count);<br />
void sdsfreesplitres(sds *tokens, int count);<br />
void sdstolower(sds s);<br />
void sdstoupper(sds s);<br />
sds sdsfromlonglong(long long value);<br />
sds sdscatrepr(sds s, const char *p, size_t len);<br />
sds *sdssplitargs(const char *line, int *argc);<br />
sds sdsmapchars(sds s, const char *from, const char *to, size_t setlen);<br />
sds sdsjoin(char **argv, int argc, char *sep);<br />
sds sdsjoinsds(sds *argv, int argc, const char *sep, size_t seplen);

/* Low level functions exposed to the user API */<br />
sds sdsMakeRoomFor(sds s, size_t addlen);<br />
void sdsIncrLen(sds s, int incr);<br />
sds sdsRemoveFreeSpace(sds s);<br />
size_t sdsAllocSize(sds s);<br />
void *sdsAllocPtr(sds s);

/* Export the allocator used by SDS to the program using SDS.<br />
 * Sometimes the program SDS is linked to, may use a different set of<br />
 * allocators, but may want to allocate or free things that SDS will<br />
 * respectively free or allocate. */<br />
void *sds_malloc(size_t size);<br />
void *sds_realloc(void *ptr, size_t size);<br />
void sds_free(void *ptr);

#ifdef REDIS_TEST<br />
int sdsTest(int argc, char *argv[]);<br />
#endif

#endif</pre>
</div>
</div>
<p>sds.c :</p>
<div>
<div>
<pre class="prettyprint linenums">/* SDSLib 2.0 -- A C dynamic strings library<br />
 */

#include &lt;stdio.h&gt;<br />
#include &lt;stdlib.h&gt;<br />
#include &lt;string.h&gt;<br />
#include &lt;ctype.h&gt;<br />
#include &lt;assert.h&gt;<br />
#include "sds.h"<br />
#include "sdsalloc.h"

// 获取type类型的sds对应的头部类型大小<br />
static inline int sdsHdrSize(char type) {<br />
    switch(type&amp;SDS_TYPE_MASK) {<br />
        case SDS_TYPE_5:<br />
            return sizeof(struct sdshdr5);<br />
        case SDS_TYPE_8:<br />
            return sizeof(struct sdshdr8);<br />
        case SDS_TYPE_16:<br />
            return sizeof(struct sdshdr16);<br />
        case SDS_TYPE_32:<br />
            return sizeof(struct sdshdr32);<br />
        case SDS_TYPE_64:<br />
            return sizeof(struct sdshdr64);<br />
    }<br />
    return ;<br />
}

// 根据不同大小选用不同类型的sds头部<br />
static inline char sdsReqType(size_t string_size) {<br />
    if (string_size &lt; &lt;&lt;) // 0~2^5-1<br />
        return SDS_TYPE_5;<br />
    if (string_size &lt; &lt;&lt;) // 2^5~2^8-1<br />
        return SDS_TYPE_8;<br />
    if (string_size &lt; &lt;&lt;) // 2^8~2^16-1<br />
        return SDS_TYPE_16;<br />
    if (string_size &lt; &lt;&lt;) // 2^16~2^32-1<br />
        return SDS_TYPE_32;<br />
    return SDS_TYPE_64; // 2^32~<br />
}

/* Create a new sds string with the content specified by the 'init' pointer<br />
 * and 'initlen'.<br />
 * If NULL is used for 'init' the string is initialized with zero bytes.<br />
 *<br />
 * The string is always null-termined (all the sds strings are, always) so<br />
 * even if you create an sds string with:<br />
 *<br />
 * mystring = sdsnewlen("abc",3);<br />
 *<br />
 * You can print the string with printf() as there is an implicit \0 at the<br />
 * end of the string. However the string is binary safe and can contain<br />
 * \0 characters in the middle, as the length is stored in the sds header. */

// sds尾部隐含有一个'\0'；sds是以len字段来判断是否到达字符串末尾<br />
// 所以sds存储的字符串中间可以出现'\0'，即sds字符串是二进制安全的

// 分配一个新sds，buf数组存储内容init<br />
sds sdsnewlen(const void *init, size_t initlen) {<br />
    void *sh;<br />
    sds s;<br />
    char type = sdsReqType(initlen); // 根据长度大小选择合适的sds头部<br />
    /* Empty strings are usually created in order to append. Use type 8<br />
     * since type 5 is not good at this. */<br />
    if (type == SDS_TYPE_5 &amp;&amp; initlen == ) type = SDS_TYPE_8;<br />
    int hdrlen = sdsHdrSize(type); // 获取sds头部大小<br />
    unsigned char *fp; /* flags pointer. */

    // 为sds分配内存，总大小为：头部大小+存储字符串的长度+末尾隐含的空字符大小<br />
    sh = s_malloc(hdrlen+initlen+);<br />
    if (!init)<br />
        memset(sh, , hdrlen+initlen+); // 内存初始化为0<br />
    if (sh == NULL) return NULL;<br />
    s = (char*)sh+hdrlen; // buf数组的起始地址<br />
    fp = ((unsigned char*)s)-; // 指向flags字段<br />
    // 初始化sds头部的len,alloc,flags字段<br />
    switch(type) {<br />
        case SDS_TYPE_5: {<br />
            *fp = type | (initlen &lt;&lt; SDS_TYPE_BITS);<br />
            break;<br />
        }<br />
        case SDS_TYPE_8: {<br />
            SDS_HDR_VAR(,s);<br />
            sh-&gt;len = initlen;<br />
            sh-&gt;alloc = initlen;<br />
            *fp = type;<br />
            break;<br />
        }<br />
        case SDS_TYPE_16: {<br />
            SDS_HDR_VAR(,s);<br />
            sh-&gt;len = initlen;<br />
            sh-&gt;alloc = initlen;<br />
            *fp = type;<br />
            break;<br />
        }<br />
        case SDS_TYPE_32: {<br />
            SDS_HDR_VAR(,s);<br />
            sh-&gt;len = initlen;<br />
            sh-&gt;alloc = initlen;<br />
            *fp = type;<br />
            break;<br />
        }<br />
        case SDS_TYPE_64: {<br />
            SDS_HDR_VAR(,s);<br />
            sh-&gt;len = initlen;<br />
            sh-&gt;alloc = initlen;<br />
            *fp = type;<br />
            break;<br />
        }<br />
    }<br />
    // 初始化buf数组<br />
    if (initlen &amp;&amp; init)<br />
        memcpy(s, init, initlen); // 拷贝init到buf数组<br />
    s[initlen] = '\0'; // 添加末尾的空字符<br />
    return s;<br />
}

/* Create an empty (zero length) sds string. Even in this case the string<br />
 * always has an implicit null term. */<br />
// 分配一个空的sds<br />
sds sdsempty(void) {<br />
    return sdsnewlen("",);<br />
}

/* Create a new sds string starting from a null terminated C string. */<br />
// 分配一个新sds，以c字符串初始化其buf数组<br />
sds sdsnew(const char *init) {<br />
    size_t initlen = (init == NULL) ?  : strlen(init);<br />
    return sdsnewlen(init, initlen);<br />
}

/* Duplicate an sds string. */<br />
// 复制一个sds<br />
sds sdsdup(const sds s) {<br />
    return sdsnewlen(s, sdslen(s));<br />
}

/* Free an sds string. No operation is performed if 's' is NULL. */<br />
// 释放一个sds<br />
void sdsfree(sds s) {<br />
    if (s == NULL) return;<br />
    s_free((char*)s-sdsHdrSize(s[-])); // 先移动到sds头部起始地址，再释放<br />
}

/* Set the sds string length to the length as obtained with strlen(), so<br />
 * considering as content only up to the first null term character.<br />
 *<br />
 * This function is useful when the sds string is hacked manually in some<br />
 * way, like in the following example:<br />
 *<br />
 * s = sdsnew("foobar");<br />
 * s[2] = '\0';<br />
 * sdsupdatelen(s);<br />
 * printf("%d\n", sdslen(s));<br />
 *<br />
 * The output will be "2", but if we comment out the call to sdsupdatelen()<br />
 * the output will be "6" as the string was modified but the logical length<br />
 * remains 6 bytes. */

 // 以第1个'\0'位置为sds长度，重新设置sds长度<br />
 // 这样做目的是将第一个'\0'后面的部分全部截断<br />
void sdsupdatelen(sds s) {<br />
    int reallen = strlen(s); // 以strlen()来计算长度，到第1个'\0'截止<br />
    sdssetlen(s, reallen);<br />
}

/* Modify an sds string in-place to make it empty (zero length).<br />
 * However all the existing buffer is not discarded but set as free space<br />
 * so that next append operations will not require allocations up to the<br />
 * number of bytes previously available. */

 // 清空sds内容，len字段清为0<br />
 // 但之前的空间并未释放，可避免以后的重新分配内存。实现惰性空间释放<br />
void sdsclear(sds s) {<br />
    sdssetlen(s, );<br />
    s[] = '\0';<br />
}

/* Enlarge the free space at the end of the sds string so that the caller<br />
 * is sure that after calling this function can overwrite up to addlen<br />
 * bytes after the end of the string, plus one more byte for nul term.<br />
 *<br />
 * Note: this does not change the *length* of the sds string as returned<br />
 * by sdslen(), but only the free buffer space we have. */

 // 为sds的len字段增加addlen个字节，剩余空间不足时会引起空间重新分配<br />
sds sdsMakeRoomFor(sds s, size_t addlen) {<br />
    void *sh, *newsh;<br />
    size_t avail = sdsavail(s);<br />
    size_t len, newlen;<br />
    char type, oldtype = s[-] &amp; SDS_TYPE_MASK;<br />
    int hdrlen;

    /* Return ASAP if there is enough space left. */<br />
    if (avail &gt;= addlen) return s; // sds剩余空间足够

    len = sdslen(s);<br />
    sh = (char*)s-sdsHdrSize(oldtype);<br />
    newlen = (len+addlen); // sds剩余空间不够，新的len为len+addlen

    // 下面两步实现空间预分配<br />
    if (newlen &lt; SDS_MAX_PREALLOC) // 新长度小于1M，则len设为2*(len+addlen)大小<br />
        newlen *= ;<br />
    else<br />
        newlen += SDS_MAX_PREALLOC; // 新长度大于1M，则len设为 len+1M 大小

    type = sdsReqType(newlen); // 新len对应的sds头部

    /* Don't use type 5: the user is appending to the string and type 5 is<br />
     * not able to remember empty space, so sdsMakeRoomFor() must be called<br />
     * at every appending operation. */<br />
    if (type == SDS_TYPE_5) type = SDS_TYPE_8;

    hdrlen = sdsHdrSize(type);<br />
    if (oldtype==type) {<br />
        newsh = s_realloc(sh, hdrlen+newlen+);<br />
        if (newsh == NULL) return NULL;<br />
        s = (char*)newsh+hdrlen;<br />
    } else {<br />
        /* Since the header size changes, need to move the string forward,<br />
         * and can't use realloc */<br />
        newsh = s_malloc(hdrlen+newlen+);<br />
        if (newsh == NULL) return NULL;<br />
        memcpy((char*)newsh+hdrlen, s, len+);<br />
        s_free(sh);<br />
        s = (char*)newsh+hdrlen;<br />
        s[-] = type;<br />
        sdssetlen(s, len);<br />
    }<br />
    sdssetalloc(s, newlen);<br />
    return s;<br />
}

/* Reallocate the sds string so that it has no free space at the end. The<br />
 * contained string remains not altered, but next concatenation operations<br />
 * will require a reallocation.<br />
 *<br />
 * After the call, the passed sds string is no longer valid and all the<br />
 * references must be substituted with the new pointer returned by the call. */<br />
sds sdsRemoveFreeSpace(sds s) {<br />
    void *sh, *newsh;<br />
    char type, oldtype = s[-] &amp; SDS_TYPE_MASK;<br />
    int hdrlen;<br />
    size_t len = sdslen(s);<br />
    sh = (char*)s-sdsHdrSize(oldtype);

    type = sdsReqType(len);<br />
    hdrlen = sdsHdrSize(type);<br />
    if (oldtype==type) {<br />
        newsh = s_realloc(sh, hdrlen+len+);<br />
        if (newsh == NULL) return NULL;<br />
        s = (char*)newsh+hdrlen;<br />
    } else {<br />
        newsh = s_malloc(hdrlen+len+);<br />
        if (newsh == NULL) return NULL;<br />
        memcpy((char*)newsh+hdrlen, s, len+);<br />
        s_free(sh);<br />
        s = (char*)newsh+hdrlen;<br />
        s[-] = type;<br />
        sdssetlen(s, len);<br />
    }<br />
    sdssetalloc(s, len);<br />
    return s;<br />
}

/* Return the total size of the allocation of the specifed sds string,<br />
 * including:<br />
 * 1) The sds header before the pointer.<br />
 * 2) The string.<br />
 * 3) The free buffer at the end if any.<br />
 * 4) The implicit null term.<br />
 */<br />
 // 返回sds的总长度：sds头部+alloc字段+结尾的空字符<br />
size_t sdsAllocSize(sds s) {<br />
    size_t alloc = sdsalloc(s);<br />
    return sdsHdrSize(s[-])+alloc+;<br />
}

/* Return the pointer of the actual SDS allocation (normally SDS strings<br />
 * are referenced by the start of the string buffer). */<br />
 // 返回sds的起始地址<br />
void *sdsAllocPtr(sds s) {<br />
    return (void*) (s-sdsHdrSize(s[-]));<br />
}

/* Increment the sds length and decrements the left free space at the<br />
 * end of the string according to 'incr'. Also set the null term<br />
 * in the new end of the string.<br />
 *<br />
 * This function is used in order to fix the string length after the<br />
 * user calls sdsMakeRoomFor(), writes something after the end of<br />
 * the current string, and finally needs to set the new length.<br />
 *<br />
 * Note: it is possible to use a negative increment in order to<br />
 * right-trim the string.<br />
 *<br />
 * Usage example:<br />
 *<br />
 * Using sdsIncrLen() and sdsMakeRoomFor() it is possible to mount the<br />
 * following schema, to cat bytes coming from the kernel to the end of an<br />
 * sds string without copying into an intermediate buffer:<br />
 *<br />
 * oldlen = sdslen(s);<br />
 * s = sdsMakeRoomFor(s, BUFFER_SIZE);<br />
 * nread = read(fd, s+oldlen, BUFFER_SIZE);<br />
 * ... check for nread &lt;= 0 and handle it ...<br />
 * sdsIncrLen(s, nread);<br />
 */

 // 更新sds的len字段，incr可以为负，表示减少len<br />
void sdsIncrLen(sds s, int incr) {<br />
    unsigned char flags = s[-];<br />
    size_t len;<br />
    switch(flags&amp;SDS_TYPE_MASK) {<br />
        case SDS_TYPE_5: {<br />
            unsigned char *fp = ((unsigned char*)s)-;<br />
            unsigned char oldlen = SDS_TYPE_5_LEN(flags);<br />
            assert((incr &gt;  &amp;&amp; oldlen+incr &lt; ) || (incr &lt;  &amp;&amp; oldlen &gt;= (unsigned int)(-incr)));<br />
            *fp = SDS_TYPE_5 | ((oldlen+incr) &lt;&lt; SDS_TYPE_BITS);<br />
            len = oldlen+incr;<br />
            break;<br />
        }<br />
        case SDS_TYPE_8: {<br />
            SDS_HDR_VAR(,s);<br />
            assert((incr &gt;=  &amp;&amp; sh-&gt;alloc-sh-&gt;len &gt;= incr) || (incr &lt;  &amp;&amp; sh-&gt;len &gt;= (unsigned int)(-incr)));<br />
            len = (sh-&gt;len += incr);<br />
            break;<br />
        }<br />
        case SDS_TYPE_16: {<br />
            SDS_HDR_VAR(,s);<br />
            assert((incr &gt;=  &amp;&amp; sh-&gt;alloc-sh-&gt;len &gt;= incr) || (incr &lt;  &amp;&amp; sh-&gt;len &gt;= (unsigned int)(-incr)));<br />
            len = (sh-&gt;len += incr);<br />
            break;<br />
        }<br />
        case SDS_TYPE_32: {<br />
            SDS_HDR_VAR(,s);<br />
            assert((incr &gt;=  &amp;&amp; sh-&gt;alloc-sh-&gt;len &gt;= (unsigned int)incr) || (incr &lt;  &amp;&amp; sh-&gt;len &gt;= (unsigned int)(-incr)));<br />
            len = (sh-&gt;len += incr);<br />
            break;<br />
        }<br />
        case SDS_TYPE_64: {<br />
            SDS_HDR_VAR(,s);<br />
            assert((incr &gt;=  &amp;&amp; sh-&gt;alloc-sh-&gt;len &gt;= (uint64_t)incr) || (incr &lt;  &amp;&amp; sh-&gt;len &gt;= (uint64_t)(-incr)));<br />
            len = (sh-&gt;len += incr);<br />
            break;<br />
        }<br />
        default: len = ; /* Just to avoid compilation warnings. */<br />
    }<br />
    s[len] = '\0';<br />
}

/* Grow the sds to have the specified length. Bytes that were not part of<br />
 * the original length of the sds will be set to zero.<br />
 *<br />
 * if the specified length is smaller than the current length, no operation<br />
 * is performed. */

 // 为sds分配len大小的空间，len小于目前的len字段，则什么都不做<br />
sds sdsgrowzero(sds s, size_t len) {<br />
    size_t curlen = sdslen(s);

    if (len &lt;= curlen) return s;<br />
    s = sdsMakeRoomFor(s,len-curlen);<br />
    if (s == NULL) return NULL;

    /* Make sure added region doesn't contain garbage */<br />
    memset(s+curlen,,(len-curlen+)); /* also set trailing \0 byte */<br />
    sdssetlen(s, len);<br />
    return s;<br />
}

/* Append the specified binary-safe string pointed by 't' of 'len' bytes to the<br />
 * end of the specified sds string 's'.<br />
 *<br />
 * After the call, the passed sds string is no longer valid and all the<br />
 * references must be substituted with the new pointer returned by the call. */

 // 在原sds后追加内容*t<br />
sds sdscatlen(sds s, const void *t, size_t len) {<br />
    size_t curlen = sdslen(s);

    s = sdsMakeRoomFor(s,len);<br />
    if (s == NULL) return NULL;<br />
    memcpy(s+curlen, t, len);<br />
    sdssetlen(s, curlen+len);<br />
    s[curlen+len] = '\0';<br />
    return s;<br />
}

/* Append the specified null termianted C string to the sds string 's'.<br />
 *<br />
 * After the call, the passed sds string is no longer valid and all the<br />
 * references must be substituted with the new pointer returned by the call. */

 // 在原sds后追加字符串<br />
sds sdscat(sds s, const char *t) {<br />
    return sdscatlen(s, t, strlen(t));<br />
}

/* Append the specified sds 't' to the existing sds 's'.<br />
 *<br />
 * After the call, the modified sds string is no longer valid and all the<br />
 * references must be substituted with the new pointer returned by the call. */

  // 在原sds后追加sds<br />
sds sdscatsds(sds s, const sds t) {<br />
    return sdscatlen(s, t, sdslen(t));<br />
}

/* Destructively modify the sds string 's' to hold the specified binary<br />
 * safe string pointed by 't' of length 'len' bytes. */

 // 将长度为len的字符串*t拷贝到sds<br />
sds sdscpylen(sds s, const char *t, size_t len) {<br />
    if (sdsalloc(s) &lt; len) {<br />
        s = sdsMakeRoomFor(s,len-sdslen(s));<br />
        if (s == NULL) return NULL;<br />
    }<br />
    memcpy(s, t, len);<br />
    s[len] = '\0';<br />
    sdssetlen(s, len);<br />
    return s;<br />
}

/* Like sdscpylen() but 't' must be a null-termined string so that the length<br />
 * of the string is obtained with strlen(). */<br />
  // 将字符串*t拷贝到sds<br />
sds sdscpy(sds s, const char *t) {<br />
    return sdscpylen(s, t, strlen(t));<br />
}

/* Helper for sdscatlonglong() doing the actual number -&gt; string<br />
 * conversion. 's' must point to a string with room for at least<br />
 * SDS_LLSTR_SIZE bytes.<br />
 *<br />
 * The function returns the length of the null-terminated string<br />
 * representation stored at 's'. */<br />
#define SDS_LLSTR_SIZE 21

// 将一个long long类型的值转换为一个字符串<br />
int sdsll2str(char *s, long long value) {<br />
    char *p, aux;<br />
    unsigned long long v;<br />
    size_t l;

    /* Generate the string representation, this method produces<br />
     * an reversed string. */<br />
    v = (value &lt; ) ? -value : value;<br />
    p = s;<br />
    do {<br />
        *p++ = ''+(v%);<br />
        v /= ;<br />
    } while(v);<br />
    if (value &lt; ) *p++ = '-';

    /* Compute length and add null term. */<br />
    l = p-s;<br />
    *p = '\0';

    /* Reverse the string. */<br />
    p--;<br />
    while(s &lt; p) {<br />
        aux = *s;<br />
        *s = *p;<br />
        *p = aux;<br />
        s++;<br />
        p--;<br />
    }<br />
    return l;<br />
}

/* Identical sdsll2str(), but for unsigned long long type. */

// 将一个unsigned long long类型的值转换为一个字符串<br />
int sdsull2str(char *s, unsigned long long v) {<br />
    char *p, aux;<br />
    size_t l;

    /* Generate the string representation, this method produces<br />
     * an reversed string. */<br />
    p = s;<br />
    do {<br />
        *p++ = ''+(v%);<br />
        v /= ;<br />
    } while(v);

    /* Compute length and add null term. */<br />
    l = p-s;<br />
    *p = '\0';

    /* Reverse the string. */<br />
    p--;<br />
    while(s &lt; p) {<br />
        aux = *s;<br />
        *s = *p;<br />
        *p = aux;<br />
        s++;<br />
        p--;<br />
    }<br />
    return l;<br />
}

/* Create an sds string from a long long value. It is much faster than:<br />
 *<br />
 * sdscatprintf(sdsempty(),"%lld\n", value);<br />
 */

 // 将一个long long类型的值以字符串的形式保存为sds<br />
sds sdsfromlonglong(long long value) {<br />
    char buf[SDS_LLSTR_SIZE];<br />
    int len = sdsll2str(buf,value);

    return sdsnewlen(buf,len);<br />
}

/* Like sdscatprintf() but gets va_list instead of being variadic. */

// 打印不定参数的内容到sds<br />
sds sdscatvprintf(sds s, const char *fmt, va_list ap) {<br />
    va_list cpy;<br />
    char staticbuf[], *buf = staticbuf, *t;<br />
    size_t buflen = strlen(fmt)*;

    /* We try to start using a static buffer for speed.<br />
     * If not possible we revert to heap allocation. */<br />
    if (buflen &gt; sizeof(staticbuf)) {<br />
        buf = s_malloc(buflen);<br />
        if (buf == NULL) return NULL;<br />
    } else {<br />
        buflen = sizeof(staticbuf);<br />
    }

    /* Try with buffers two times bigger every time we fail to<br />
     * fit the string in the current buffer size. */<br />
    while() {<br />
        buf[buflen-] = '\0';<br />
        va_copy(cpy,ap);<br />
        vsnprintf(buf, buflen, fmt, cpy);<br />
        va_end(cpy);<br />
        if (buf[buflen-] != '\0') {<br />
            if (buf != staticbuf) s_free(buf);<br />
            buflen *= ;<br />
            buf = s_malloc(buflen);<br />
            if (buf == NULL) return NULL;<br />
            continue;<br />
        }<br />
        break;<br />
    }

    /* Finally concat the obtained string to the SDS string and return it. */<br />
    t = sdscat(s, buf);<br />
    if (buf != staticbuf) s_free(buf);<br />
    return t;<br />
}

/* Append to the sds string 's' a string obtained using printf-alike format<br />
 * specifier.<br />
 *<br />
 * After the call, the modified sds string is no longer valid and all the<br />
 * references must be substituted with the new pointer returned by the call.<br />
 *<br />
 * Example:<br />
 *<br />
 * s = sdsnew("Sum is: ");<br />
 * s = sdscatprintf(s,"%d+%d = %d",a,b,a+b).<br />
 *<br />
 * Often you need to create a string from scratch with the printf-alike<br />
 * format. When this is the need, just use sdsempty() as the target string:<br />
 *<br />
 * s = sdscatprintf(sdsempty(), "... your format ...", args);<br />
 */

// 打印不定参数的内容到sds<br />
sds sdscatprintf(sds s, const char *fmt, ...) {<br />
    va_list ap;<br />
    char *t;<br />
    va_start(ap, fmt);<br />
    t = sdscatvprintf(s,fmt,ap);<br />
    va_end(ap);<br />
    return t;<br />
}

/* This function is similar to sdscatprintf, but much faster as it does<br />
 * not rely on sprintf() family functions implemented by the libc that<br />
 * are often very slow. Moreover directly handling the sds string as<br />
 * new data is concatenated provides a performance improvement.<br />
 *<br />
 * However this function only handles an incompatible subset of printf-alike<br />
 * format specifiers:<br />
 *<br />
 * %s - C String<br />
 * %S - SDS string<br />
 * %i - signed int<br />
 * %I - 64 bit signed integer (long long, int64_t)<br />
 * %u - unsigned int<br />
 * %U - 64 bit unsigned integer (unsigned long long, uint64_t)<br />
 * %% - Verbatim "%" character.<br />
 */

 // 格式化输出字符串到sds<br />
sds sdscatfmt(sds s, char const *fmt, ...) {<br />
    size_t initlen = sdslen(s);<br />
    const char *f = fmt;<br />
    int i;<br />
    va_list ap;

    va_start(ap,fmt);<br />
    f = fmt;    /* Next format specifier byte to process. */<br />
    i = initlen; /* Position of the next byte to write to dest str. */<br />
    while(*f) {<br />
        char next, *str;<br />
        size_t l;<br />
        long long num;<br />
        unsigned long long unum;

        /* Make sure there is always space for at least 1 char. */<br />
        if (sdsavail(s)==) {<br />
            s = sdsMakeRoomFor(s,);<br />
        }

        switch(*f) {<br />
        case '%':<br />
            next = *(f+);<br />
            f++;<br />
            switch(next) {<br />
            case 's':<br />
            case 'S':<br />
                str = va_arg(ap,char*);<br />
                l = (next == 's') ? strlen(str) : sdslen(str);<br />
                if (sdsavail(s) &lt; l) {<br />
                    s = sdsMakeRoomFor(s,l);<br />
                }<br />
                memcpy(s+i,str,l);<br />
                sdsinclen(s,l);<br />
                i += l;<br />
                break;<br />
            case 'i':<br />
            case 'I':<br />
                if (next == 'i')<br />
                    num = va_arg(ap,int);<br />
                else<br />
                    num = va_arg(ap,long long);<br />
                {<br />
                    char buf[SDS_LLSTR_SIZE];<br />
                    l = sdsll2str(buf,num);<br />
                    if (sdsavail(s) &lt; l) {<br />
                        s = sdsMakeRoomFor(s,l);<br />
                    }<br />
                    memcpy(s+i,buf,l);<br />
                    sdsinclen(s,l);<br />
                    i += l;<br />
                }<br />
                break;<br />
            case 'u':<br />
            case 'U':<br />
                if (next == 'u')<br />
                    unum = va_arg(ap,unsigned int);<br />
                else<br />
                    unum = va_arg(ap,unsigned long long);<br />
                {<br />
                    char buf[SDS_LLSTR_SIZE];<br />
                    l = sdsull2str(buf,unum);<br />
                    if (sdsavail(s) &lt; l) {<br />
                        s = sdsMakeRoomFor(s,l);<br />
                    }<br />
                    memcpy(s+i,buf,l);<br />
                    sdsinclen(s,l);<br />
                    i += l;<br />
                }<br />
                break;<br />
            default: /* Handle %% and generally %&lt;unknown&gt;. */<br />
                s[i++] = next;<br />
                sdsinclen(s,);<br />
                break;<br />
            }<br />
            break;<br />
        default:<br />
            s[i++] = *f;<br />
            sdsinclen(s,);<br />
            break;<br />
        }<br />
        f++;<br />
    }<br />
    va_end(ap);

    /* Add null-term */<br />
    s[i] = '\0';<br />
    return s;<br />
}

/* Remove the part of the string from left and from right composed just of<br />
 * contiguous characters found in 'cset', that is a null terminted C string.<br />
 *<br />
 * After the call, the modified sds string is no longer valid and all the<br />
 * references must be substituted with the new pointer returned by the call.<br />
 *<br />
 * Example:<br />
 *<br />
 * s = sdsnew("AA...AA.a.aa.aHelloWorld     :::");<br />
 * s = sdstrim(s,"Aa. :");<br />
 * printf("%s\n", s);<br />
 *<br />
 * Output will be just "Hello World".<br />
 */<br />
sds sdstrim(sds s, const char *cset) {<br />
    char *start, *end, *sp, *ep;<br />
    size_t len;

    sp = start = s;<br />
    ep = end = s+sdslen(s)-;<br />
    while(sp &lt;= end &amp;&amp; strchr(cset, *sp)) sp++;<br />
    while(ep &gt; sp &amp;&amp; strchr(cset, *ep)) ep--;<br />
    len = (sp &gt; ep) ?  : ((ep-sp)+);<br />
    if (s != sp) memmove(s, sp, len);<br />
    s[len] = '\0';<br />
    sdssetlen(s,len);<br />
    return s;<br />
}

/* Turn the string into a smaller (or equal) string containing only the<br />
 * substring specified by the 'start' and 'end' indexes.<br />
 *<br />
 * start and end can be negative, where -1 means the last character of the<br />
 * string, -2 the penultimate character, and so forth.<br />
 *<br />
 * The interval is inclusive, so the start and end characters will be part<br />
 * of the resulting string.<br />
 *<br />
 * The string is modified in-place.<br />
 *<br />
 * Example:<br />
 *<br />
 * s = sdsnew("Hello World");<br />
 * sdsrange(s,1,-1); =&gt; "ello World"<br />
 */<br />
void sdsrange(sds s, int start, int end) {<br />
    size_t newlen, len = sdslen(s);

    if (len == ) return;<br />
    if (start &lt; ) {<br />
        start = len+start;<br />
        if (start &lt; ) start = ;<br />
    }<br />
    if (end &lt; ) {<br />
        end = len+end;<br />
        if (end &lt; ) end = ;<br />
    }<br />
    newlen = (start &gt; end) ?  : (end-start)+;<br />
    if (newlen != ) {<br />
        if (start &gt;= (signed)len) {<br />
            newlen = ;<br />
        } else if (end &gt;= (signed)len) {<br />
            end = len-;<br />
            newlen = (start &gt; end) ?  : (end-start)+;<br />
        }<br />
    } else {<br />
        start = ;<br />
    }<br />
    if (start &amp;&amp; newlen) memmove(s, s+start, newlen);<br />
    s[newlen] = ;<br />
    sdssetlen(s,newlen);<br />
}

/* Apply tolower() to every character of the sds string 's'. */<br />
void sdstolower(sds s) {<br />
    int len = sdslen(s), j;

    for (j = ; j &lt; len; j++) s[j] = tolower(s[j]);<br />
}

/* Apply toupper() to every character of the sds string 's'. */<br />
void sdstoupper(sds s) {<br />
    int len = sdslen(s), j;

    for (j = ; j &lt; len; j++) s[j] = toupper(s[j]);<br />
}

/* Compare two sds strings s1 and s2 with memcmp().<br />
 *<br />
 * Return value:<br />
 *<br />
 *     positive if s1 &gt; s2.<br />
 *     negative if s1 &lt; s2.<br />
 *     0 if s1 and s2 are exactly the same binary string.<br />
 *<br />
 * If two strings share exactly the same prefix, but one of the two has<br />
 * additional characters, the longer string is considered to be greater than<br />
 * the smaller one. */<br />
int sdscmp(const sds s1, const sds s2) {<br />
    size_t l1, l2, minlen;<br />
    int cmp;

    l1 = sdslen(s1);<br />
    l2 = sdslen(s2);<br />
    minlen = (l1 &lt; l2) ? l1 : l2;<br />
    cmp = memcmp(s1,s2,minlen);<br />
    if (cmp == ) return l1-l2;<br />
    return cmp;<br />
}

/* Split 's' with separator in 'sep'. An array<br />
 * of sds strings is returned. *count will be set<br />
 * by reference to the number of tokens returned.<br />
 *<br />
 * On out of memory, zero length string, zero length<br />
 * separator, NULL is returned.<br />
 *<br />
 * Note that 'sep' is able to split a string using<br />
 * a multi-character separator. For example<br />
 * sdssplit("foo_-_bar","_-_"); will return two<br />
 * elements "foo" and "bar".<br />
 *<br />
 * This version of the function is binary-safe but<br />
 * requires length arguments. sdssplit() is just the<br />
 * same function but for zero-terminated strings.<br />
 */<br />
sds *sdssplitlen(const char *s, int len, const char *sep, int seplen, int *count) {<br />
    int elements = , slots = , start = , j;<br />
    sds *tokens;

    if (seplen &lt;  || len &lt; ) return NULL;

    tokens = s_malloc(sizeof(sds)*slots);<br />
    if (tokens == NULL) return NULL;

    if (len == ) {<br />
        *count = ;<br />
        return tokens;<br />
    }<br />
    for (j = ; j &lt; (len-(seplen-)); j++) {<br />
        /* make sure there is room for the next element and the final one */<br />
        if (slots &lt; elements+) {<br />
            sds *newtokens;

            slots *= ;<br />
            newtokens = s_realloc(tokens,sizeof(sds)*slots);<br />
            if (newtokens == NULL) goto cleanup;<br />
            tokens = newtokens;<br />
        }<br />
        /* search the separator */<br />
        if ((seplen ==  &amp;&amp; *(s+j) == sep[]) || (memcmp(s+j,sep,seplen) == )) {<br />
            tokens[elements] = sdsnewlen(s+start,j-start);<br />
            if (tokens[elements] == NULL) goto cleanup;<br />
            elements++;<br />
            start = j+seplen;<br />
            j = j+seplen-; /* skip the separator */<br />
        }<br />
    }<br />
    /* Add the final element. We are sure there is room in the tokens array. */<br />
    tokens[elements] = sdsnewlen(s+start,len-start);<br />
    if (tokens[elements] == NULL) goto cleanup;<br />
    elements++;<br />
    *count = elements;<br />
    return tokens;

cleanup:<br />
    {<br />
        int i;<br />
        for (i = ; i &lt; elements; i++) sdsfree(tokens[i]);<br />
        s_free(tokens);<br />
        *count = ;<br />
        return NULL;<br />
    }<br />
}

/* Free the result returned by sdssplitlen(), or do nothing if 'tokens' is NULL. */<br />
void sdsfreesplitres(sds *tokens, int count) {<br />
    if (!tokens) return;<br />
    while(count--)<br />
        sdsfree(tokens[count]);<br />
    s_free(tokens);<br />
}

/* Append to the sds string "s" an escaped string representation where<br />
 * all the non-printable characters (tested with isprint()) are turned into<br />
 * escapes in the form "\n\r\a...." or "\x&lt;hex-number&gt;".<br />
 *<br />
 * After the call, the modified sds string is no longer valid and all the<br />
 * references must be substituted with the new pointer returned by the call. */<br />
sds sdscatrepr(sds s, const char *p, size_t len) {<br />
    s = sdscatlen(s,"\"",);<br />
    while(len--) {<br />
        switch(*p) {<br />
        case '\\':<br />
        case '"':<br />
            s = sdscatprintf(s,"\\%c",*p);<br />
            break;<br />
        case '\n': s = sdscatlen(s,"\\n",); break;<br />
        case '\r': s = sdscatlen(s,"\\r",); break;<br />
        case '\t': s = sdscatlen(s,"\\t",); break;<br />
        case '\a': s = sdscatlen(s,"\\a",); break;<br />
        case '\b': s = sdscatlen(s,"\\b",); break;<br />
        default:<br />
            if (isprint(*p))<br />
                s = sdscatprintf(s,"%c",*p);<br />
            else<br />
                s = sdscatprintf(s,"\\x%02x",(unsigned char)*p);<br />
            break;<br />
        }<br />
        p++;<br />
    }<br />
    return sdscatlen(s,"\"",);<br />
}

/* Helper function for sdssplitargs() that returns non zero if 'c'<br />
 * is a valid hex digit. */<br />
int is_hex_digit(char c) {<br />
    return (c &gt;= '' &amp;&amp; c &lt;= '') || (c &gt;= 'a' &amp;&amp; c &lt;= 'f') ||<br />
           (c &gt;= 'A' &amp;&amp; c &lt;= 'F');<br />
}

/* Helper function for sdssplitargs() that converts a hex digit into an<br />
 * integer from 0 to 15 */<br />
int hex_digit_to_int(char c) {<br />
    switch(c) {<br />
    case '': return ;<br />
    case '': return ;<br />
    case '': return ;<br />
    case '': return ;<br />
    case '': return ;<br />
    case '': return ;<br />
    case '': return ;<br />
    case '': return ;<br />
    case '': return ;<br />
    case '': return ;<br />
    case 'a': case 'A': return ;<br />
    case 'b': case 'B': return ;<br />
    case 'c': case 'C': return ;<br />
    case 'd': case 'D': return ;<br />
    case 'e': case 'E': return ;<br />
    case 'f': case 'F': return ;<br />
    default: return ;<br />
    }<br />
}

/* Split a line into arguments, where every argument can be in the<br />
 * following programming-language REPL-alike form:<br />
 *<br />
 * foo bar "newline are supported\n" and "\xff\x00otherstuff"<br />
 *<br />
 * The number of arguments is stored into *argc, and an array<br />
 * of sds is returned.<br />
 *<br />
 * The caller should free the resulting array of sds strings with<br />
 * sdsfreesplitres().<br />
 *<br />
 * Note that sdscatrepr() is able to convert back a string into<br />
 * a quoted string in the same format sdssplitargs() is able to parse.<br />
 *<br />
 * The function returns the allocated tokens on success, even when the<br />
 * input string is empty, or NULL if the input contains unbalanced<br />
 * quotes or closed quotes followed by non space characters<br />
 * as in: "foo"bar or "foo'<br />
 */<br />
sds *sdssplitargs(const char *line, int *argc) {<br />
    const char *p = line;<br />
    char *current = NULL;<br />
    char **vector = NULL;

    *argc = ;<br />
    while() {<br />
        /* skip blanks */<br />
        while(*p &amp;&amp; isspace(*p)) p++;<br />
        if (*p) {<br />
            /* get a token */<br />
            int inq=;  /* set to 1 if we are in "quotes" */<br />
            int insq=; /* set to 1 if we are in 'single quotes' */<br />
            int done=;

            if (current == NULL) current = sdsempty();<br />
            while(!done) {<br />
                if (inq) {<br />
                    if (*p == '\\' &amp;&amp; *(p+) == 'x' &amp;&amp;<br />
                                             is_hex_digit(*(p+)) &amp;&amp;<br />
                                             is_hex_digit(*(p+)))<br />
                    {<br />
                        unsigned char byte;

                        byte = (hex_digit_to_int(*(p+))*)+<br />
                                hex_digit_to_int(*(p+));<br />
                        current = sdscatlen(current,(char*)&amp;byte,);<br />
                        p += ;<br />
                    } else if (*p == '\\' &amp;&amp; *(p+)) {<br />
                        char c;

                        p++;<br />
                        switch(*p) {<br />
                        case 'n': c = '\n'; break;<br />
                        case 'r': c = '\r'; break;<br />
                        case 't': c = '\t'; break;<br />
                        case 'b': c = '\b'; break;<br />
                        case 'a': c = '\a'; break;<br />
                        default: c = *p; break;<br />
                        }<br />
                        current = sdscatlen(current,&amp;c,);<br />
                    } else if (*p == '"') {<br />
                        /* closing quote must be followed by a space or<br />
                         * nothing at all. */<br />
                        if (*(p+) &amp;&amp; !isspace(*(p+))) goto err;<br />
                        done=;<br />
                    } else if (!*p) {<br />
                        /* unterminated quotes */<br />
                        goto err;<br />
                    } else {<br />
                        current = sdscatlen(current,p,);<br />
                    }<br />
                } else if (insq) {<br />
                    if (*p == '\\' &amp;&amp; *(p+) == '\'') {<br />
                        p++;<br />
                        current = sdscatlen(current,"'",);<br />
                    } else if (*p == '\'') {<br />
                        /* closing quote must be followed by a space or<br />
                         * nothing at all. */<br />
                        if (*(p+) &amp;&amp; !isspace(*(p+))) goto err;<br />
                        done=;<br />
                    } else if (!*p) {<br />
                        /* unterminated quotes */<br />
                        goto err;<br />
                    } else {<br />
                        current = sdscatlen(current,p,);<br />
                    }<br />
                } else {<br />
                    switch(*p) {<br />
                    case ' ':<br />
                    case '\n':<br />
                    case '\r':<br />
                    case '\t':<br />
                    case '\0':<br />
                        done=;<br />
                        break;<br />
                    case '"':<br />
                        inq=;<br />
                        break;<br />
                    case '\'':<br />
                        insq=;<br />
                        break;<br />
                    default:<br />
                        current = sdscatlen(current,p,);<br />
                        break;<br />
                    }<br />
                }<br />
                if (*p) p++;<br />
            }<br />
            /* add the token to the vector */<br />
            vector = s_realloc(vector,((*argc)+)*sizeof(char*));<br />
            vector[*argc] = current;<br />
            (*argc)++;<br />
            current = NULL;<br />
        } else {<br />
            /* Even on empty input string return something not NULL. */<br />
            if (vector == NULL) vector = s_malloc(sizeof(void*));<br />
            return vector;<br />
        }<br />
    }

err:<br />
    while((*argc)--)<br />
        sdsfree(vector[*argc]);<br />
    s_free(vector);<br />
    if (current) sdsfree(current);<br />
    *argc = ;<br />
    return NULL;<br />
}

/* Modify the string substituting all the occurrences of the set of<br />
 * characters specified in the 'from' string to the corresponding character<br />
 * in the 'to' array.<br />
 *<br />
 * For instance: sdsmapchars(mystring, "ho", "01", 2)<br />
 * will have the effect of turning the string "hello" into "0ell1".<br />
 *<br />
 * The function returns the sds string pointer, that is always the same<br />
 * as the input pointer since no resize is needed. */<br />
sds sdsmapchars(sds s, const char *from, const char *to, size_t setlen) {<br />
    size_t j, i, l = sdslen(s);

    for (j = ; j &lt; l; j++) {<br />
        for (i = ; i &lt; setlen; i++) {<br />
            if (s[j] == from[i]) {<br />
                s[j] = to[i];<br />
                break;<br />
            }<br />
        }<br />
    }<br />
    return s;<br />
}

/* Join an array of C strings using the specified separator (also a C string).<br />
 * Returns the result as an sds string. */<br />
sds sdsjoin(char **argv, int argc, char *sep) {<br />
    sds join = sdsempty();<br />
    int j;

    for (j = ; j &lt; argc; j++) {<br />
        join = sdscat(join, argv[j]);<br />
        if (j != argc-) join = sdscat(join,sep);<br />
    }<br />
    return join;<br />
}

/* Like sdsjoin, but joins an array of SDS strings. */<br />
sds sdsjoinsds(sds *argv, int argc, const char *sep, size_t seplen) {<br />
    sds join = sdsempty();<br />
    int j;

    for (j = ; j &lt; argc; j++) {<br />
        join = sdscatsds(join, argv[j]);<br />
        if (j != argc-) join = sdscatlen(join,sep,seplen);<br />
    }<br />
    return join;<br />
}

/* Wrappers to the allocators used by SDS. Note that SDS will actually<br />
 * just use the macros defined into sdsalloc.h in order to avoid to pay<br />
 * the overhead of function calls. Here we define these wrappers only for<br />
 * the programs SDS is linked to, if they want to touch the SDS internals<br />
 * even if they use a different allocator. */<br />
void *sds_malloc(size_t size) { return s_malloc(size); }<br />
void *sds_realloc(void *ptr, size_t size) { return s_realloc(ptr,size); }<br />
void sds_free(void *ptr) { s_free(ptr); }

#if defined(SDS_TEST_MAIN)<br />
#include &lt;stdio.h&gt;<br />
#include "testhelp.h"<br />
#include "limits.h"

#define UNUSED(x) (void)(x)<br />
int sdsTest(void) {<br />
    {<br />
        sds x = sdsnew("foo"), y;

        test_cond("Create a string and obtain the length",<br />
            sdslen(x) ==  &amp;&amp; memcmp(x,"foo\0",) == )

        sdsfree(x);<br />
        x = sdsnewlen("foo",);<br />
        test_cond("Create a string with specified length",<br />
            sdslen(x) ==  &amp;&amp; memcmp(x,"fo\0",) == )

        x = sdscat(x,"bar");<br />
        test_cond("Strings concatenation",<br />
            sdslen(x) ==  &amp;&amp; memcmp(x,"fobar\0",) == );

        x = sdscpy(x,"a");<br />
        test_cond("sdscpy() against an originally longer string",<br />
            sdslen(x) ==  &amp;&amp; memcmp(x,"a\0",) == )

        x = sdscpy(x,"xyzxxxxxxxxxxyyyyyyyyyykkkkkkkkkk");<br />
        test_cond("sdscpy() against an originally shorter string",<br />
            sdslen(x) ==  &amp;&amp;<br />
            memcmp(x,"xyzxxxxxxxxxxyyyyyyyyyykkkkkkkkkk\0",) == )

        sdsfree(x);<br />
        x = sdscatprintf(sdsempty(),"%d",);<br />
        test_cond("sdscatprintf() seems working in the base case",<br />
            sdslen(x) ==  &amp;&amp; memcmp(x,"123\0",) == )

        sdsfree(x);<br />
        x = sdsnew("--");<br />
        x = sdscatfmt(x, "Hello %s World %I,%I--", "Hi!", LLONG_MIN,LLONG_MAX);<br />
        test_cond("sdscatfmt() seems working in the base case",<br />
            sdslen(x) ==  &amp;&amp;<br />
            memcmp(x,"--Hello Hi! World -9223372036854775808,"<br />
                     "9223372036854775807--",) == )<br />
        printf("[%s]\n",x);

        sdsfree(x);<br />
        x = sdsnew("--");<br />
        x = sdscatfmt(x, "%u,%U--", UINT_MAX, ULLONG_MAX);<br />
        test_cond("sdscatfmt() seems working with unsigned numbers",<br />
            sdslen(x) ==  &amp;&amp;<br />
            memcmp(x,"--4294967295,18446744073709551615--",) == )

        sdsfree(x);<br />
        x = sdsnew(" x ");<br />
        sdstrim(x," x");<br />
        test_cond("sdstrim() works when all chars match",<br />
            sdslen(x) == )

        sdsfree(x);<br />
        x = sdsnew(" x ");<br />
        sdstrim(x," ");<br />
        test_cond("sdstrim() works when a single char remains",<br />
            sdslen(x) ==  &amp;&amp; x[] == 'x')

        sdsfree(x);<br />
        x = sdsnew("xxciaoyyy");<br />
        sdstrim(x,"xy");<br />
        test_cond("sdstrim() correctly trims characters",<br />
            sdslen(x) ==  &amp;&amp; memcmp(x,"ciao\0",) == )

        y = sdsdup(x);<br />
        sdsrange(y,,);<br />
        test_cond("sdsrange(...,1,1)",<br />
            sdslen(y) ==  &amp;&amp; memcmp(y,"i\0",) == )

        sdsfree(y);<br />
        y = sdsdup(x);<br />
        sdsrange(y,,-);<br />
        test_cond("sdsrange(...,1,-1)",<br />
            sdslen(y) ==  &amp;&amp; memcmp(y,"iao\0",) == )

        sdsfree(y);<br />
        y = sdsdup(x);<br />
        sdsrange(y,-,-);<br />
        test_cond("sdsrange(...,-2,-1)",<br />
            sdslen(y) ==  &amp;&amp; memcmp(y,"ao\0",) == )

        sdsfree(y);<br />
        y = sdsdup(x);<br />
        sdsrange(y,,);<br />
        test_cond("sdsrange(...,2,1)",<br />
            sdslen(y) ==  &amp;&amp; memcmp(y,"\0",) == )

        sdsfree(y);<br />
        y = sdsdup(x);<br />
        sdsrange(y,,);<br />
        test_cond("sdsrange(...,1,100)",<br />
            sdslen(y) ==  &amp;&amp; memcmp(y,"iao\0",) == )

        sdsfree(y);<br />
        y = sdsdup(x);<br />
        sdsrange(y,,);<br />
        test_cond("sdsrange(...,100,100)",<br />
            sdslen(y) ==  &amp;&amp; memcmp(y,"\0",) == )

        sdsfree(y);<br />
        sdsfree(x);<br />
        x = sdsnew("foo");<br />
        y = sdsnew("foa");<br />
        test_cond("sdscmp(foo,foa)", sdscmp(x,y) &gt; )

        sdsfree(y);<br />
        sdsfree(x);<br />
        x = sdsnew("bar");<br />
        y = sdsnew("bar");<br />
        test_cond("sdscmp(bar,bar)", sdscmp(x,y) == )

        sdsfree(y);<br />
        sdsfree(x);<br />
        x = sdsnew("aar");<br />
        y = sdsnew("bar");<br />
        test_cond("sdscmp(bar,bar)", sdscmp(x,y) &lt; )

        sdsfree(y);<br />
        sdsfree(x);<br />
        x = sdsnewlen("\a\n\0foo\r",);<br />
        y = sdscatrepr(sdsempty(),x,sdslen(x));<br />
        test_cond("sdscatrepr(...data...)",<br />
            memcmp(y,"\"\\a\\n\\x00foo\\r\"",) == )

        {<br />
            unsigned int oldfree;<br />
            char *p;<br />
            int step = , j, i;

            sdsfree(x);<br />
            sdsfree(y);<br />
            x = sdsnew("");<br />
            test_cond("sdsnew() free/len buffers", sdslen(x) ==  &amp;&amp; sdsavail(x) == );

            /* Run the test a few times in order to hit the first two<br />
             * SDS header types. */<br />
            for (i = ; i &lt; ; i++) {<br />
                int oldlen = sdslen(x);<br />
                x = sdsMakeRoomFor(x,step);<br />
                int type = x[-]&amp;SDS_TYPE_MASK;

                test_cond("sdsMakeRoomFor() len", sdslen(x) == oldlen);<br />
                if (type != SDS_TYPE_5) {<br />
                    test_cond("sdsMakeRoomFor() free", sdsavail(x) &gt;= step);<br />
                    oldfree = sdsavail(x);<br />
                }<br />
                p = x+oldlen;<br />
                for (j = ; j &lt; step; j++) {<br />
                    p[j] = 'A'+j;<br />
                }<br />
                sdsIncrLen(x,step);<br />
            }<br />
            test_cond("sdsMakeRoomFor() content",<br />
                memcmp("0ABCDEFGHIJABCDEFGHIJABCDEFGHIJABCDEFGHIJABCDEFGHIJABCDEFGHIJABCDEFGHIJABCDEFGHIJABCDEFGHIJABCDEFGHIJ",x,) == );<br />
            test_cond("sdsMakeRoomFor() final length",sdslen(x)==);

            sdsfree(x);<br />
        }<br />
    }<br />
    test_report()<br />
    return ;<br />
}<br />
#endif

#ifdef SDS_TEST_MAIN<br />
int main(void) {<br />
    return sdsTest();<br />
}<br />
#endif</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kwe38j.html">浅析java内存模型--JMM&lpar;Java Memory Model&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnjek38.html">JS代码判断IE6&comma;IE7&comma;IE8&comma;IE9！</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r6v6m9.html">Senparc&period;Weixin&period;MP SDK 微信公众平台开发教程（四）：Hello World</a>
		</li>
						<li><a href="https://www.batexi.com/a/4951oy6q.html">jquery判断id是否存在</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g77wl9.html">12&period;我们不是在真空里谈软件工程， 软件要运行在硬件芯片上面， 下面看看一个计算机芯片的发展历史： http&colon;&sol;&sol;perspectives&period;mvdirona&period;com&sol;2014&sol;09&sol;august-21-2014-computer-history-museum-presentation&sol;     http&colon;&sol;&sol;mvdirona&period;com&sol;jrh&sol;TalksAndPapers&sol;DileepBhandar</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1dye28.html">JDBC 程序的常见错误及调试方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdedj4x9.html">hdu 3478（判断奇环）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wg1nxq.html">【DELPHI】线程相关</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok0l059.html">AE 3D摄像机工作原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1wj1d9.html">ELT工具Kettle之CDC（Change Data Capture）实现实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyjdpk9.html">关于MATLAB处理大数据坐标文件201763</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpz660q.html">java 得到uuid并处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojoe7xq.html">Core Animation 文档翻译&mdash;附录C（KVC扩展）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k2em59.html">洛谷 &lbrack;P1113&rsqb; 杂务</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zx5109.html">BZOJ &num;3625 CF &num;438E 小朋友和二叉树</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvldey8.html">前端入门5-CSS弹性布局flex</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o15yk5q.html">python之&plus;&equals;与&plus;&lpar;转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvge7k8.html">mybatis中的mapper接口文件以及selectByExample类的实例函数详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wz3znq.html">Jquery的deferred对象，看这2篇牛人的文章，基本就够了。</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rze1j9.html">BeanFactory的实现原理</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93p6y7z8.html">P2605 &lbrack;ZJOI2010&rsqb;基站选址</a>
			</li>
						<li><a href="https://www.batexi.com/a/qve722j9.html">【转】ORA-00054 的解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emx45z9.html">hihocoder1639 图书馆 &lbrack;数学&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1xo309.html">java多线程 -- volatile 关键字 内存 可见性</a>
			</li>
						<li><a href="https://www.batexi.com/a/953npoz8.html">JS的作用域和闭包</a>
			</li>
						<li><a href="https://www.batexi.com/a/9021jmnq.html">一、spark错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1x52x9.html">fcntl文件锁操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/qve7r3j9.html">aapt命令说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/953ndd68.html">Zabbix应用一&colon;Zabbix安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4p6dwnq.html">solr6&period;3&period;0升级与IK动态词库自动加载</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
